#property indicator_separate_window
#property indicator_buffers 2
#property indicator_minimum 0
#property indicator_maximum 1
#property strict

//
//
//
//
//
 
extern ENUM_TIMEFRAMES     TimeFrame       = PERIOD_CURRENT;  // Time frame
extern int                 Kijun           = 26;              // Kijun period
extern int                 HistoWidth      = 3;               // Histogram bars width
extern color               UpHistoColor    = clrLimeGreen;    // Kijun sloping up histogram color
extern color               DnHistoColor    = clrRed;          // Kijun sloping down histogram color
extern bool                alertsOn        = false;           // Turn alerts on?
extern bool                alertsOnCurrent = false;           // Alerts on still opened bar?
extern bool                alertsMessage   = true;            // Alerts should display message?
extern bool                alertsSound     = false;           // Alerts should play a sound?
extern bool                alertsNotify    = false;           // Alerts should send a notification?
extern bool                alertsEmail     = false;           // Alerts should send an email?
extern string              soundFile       = "alert2.wav";    // Sound file
//
//
//
//
//

double ks[];
double ksDa[];
double ksDb[];
double slope[];
double count[];

string indicatorFileName;
#define _mtfCall(_buff,_y) iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,Kijun,HistoWidth,UpHistoColor,DnHistoColor,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsNotify,alertsEmail,soundFile,_buff,_y)

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(5);
   SetIndexBuffer(0,ksDa); SetIndexStyle(0, DRAW_HISTOGRAM,EMPTY,HistoWidth,UpHistoColor);
   SetIndexBuffer(1,ksDb); SetIndexStyle(1, DRAW_HISTOGRAM,EMPTY,HistoWidth,DnHistoColor);   
   SetIndexBuffer(2,ks);
   SetIndexBuffer(3,slope);
   SetIndexBuffer(4,count);

    //
    //
    //
    //
    //
   
    indicatorFileName = WindowExpertName();
    TimeFrame         = fmax(TimeFrame,_Period); 
      
    IndicatorShortName(timeFrameToString(TimeFrame)+"  kijun slope histo histo ");    
   return(0);
}
int deinit() { return(0); }

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
    int i,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = fmin(Bars-counted_bars,Bars-1); count[0]=limit;
            if (TimeFrame!=_Period)
            {
               limit = (int)fmax(limit,fmin(Bars-1,_mtfCall(4,0)*TimeFrame/_Period));
               for (i=limit;i>=0 && !_StopFlag; i--)
               {
                  int y = iBarShift(NULL,TimeFrame,Time[i]);
                     ksDa[i]  = _mtfCall(0,y);
                     ksDb[i]  = _mtfCall(1,y);
                     
               }
            return(0);
            }               
         
       //
       //
       //
       //
       //
   
     for (i=limit; i>=0; i--)
     {
        if (i>=Bars-Kijun) continue;
        double khi = High[i];
        double klo = Low[i];
          for (int k = 1; k<Kijun; k++)
          {
             if(khi<High[i+k]) khi = High[i+k];
             if(klo>Low[i+k])  klo =  Low[i+k];
          }
          if ((khi+klo) > 0.0) 
               ks[i] = (khi+klo)*0.5; 
          else ks[i] = 0;
          ksDa[i]  = EMPTY_VALUE;
          ksDb[i]  = EMPTY_VALUE;
          slope[i] = (i<Bars-1) ? (ks[i]>ks[i+1]) ? 1 : (ks[i]<ks[i+1]) ? -1 : slope[i+1] : 0; 
          if (slope[i] ==  1) ksDa[i] = 1;
          if (slope[i] == -1) ksDb[i] = 1; 
      }
           
      //
      //
      //
      //
      //
      
      if (alertsOn)
      {
         int whichBar = 1; if (alertsOnCurrent) whichBar = 0; 
         if (slope[whichBar] != slope[whichBar+1])
         {
            if (slope[whichBar] == 1) doAlert("sloping up");
            if (slope[whichBar] ==-1) doAlert("sloping down");       
         }         
      }              
return(0);            
}

//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}
   
 //------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //
          //
          //

          message = timeFrameToString(_Period)+" "+_Symbol+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+" Kijun state changed to "+doWhat;
             if (alertsMessage) Alert(message);
             if (alertsNotify)  SendNotification(message);
             if (alertsEmail)   SendMail(_Symbol+" Kijun ",message);
             if (alertsSound)   PlaySound(soundFile);
      }
}
